/*
 * Copyright (c) Carnegie Mellon University.
 * See LICENSE.txt for the conditions of this license.
 */

package edu.cmu.cs.ls.keymaerax.btactics

/**
  * Helper functions for implementing tactics. Note that these are **not** themselves tactics.
 *
  * @see [[helpers.DifferentialHelper]] Differential Equation-specific program helpers.
  * @see [[helpers.ProgramHelpers]] Hybrid Program helpers that are not specific to Differential Equations.
  * @author Nathan Fulton
  */
package object helpers {
  import DifferentialHelper._
  import ProgramHelpers._
}
