(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5759,        176]
NotebookOptionsPosition[      5162,        159]
NotebookOutlinePosition[      5495,        174]
CellTagsIndexPosition[      5452,        171]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Makes", " ", "the", " ", "directory", " ", 
    RowBox[{"Pegasus", "/"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetDirectory", "[", 
    RowBox[{"ParentDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "]"}], ";", 
   RowBox[{"Needs", "[", 
    RowBox[{"\"\<Primitives`\>\"", ",", 
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Directory", "[", "]"}], ",", "\"\<Primitives\>\"", ",", 
        "\"\<Dependency.m\>\""}], "}"}], "]"}]}], "]"}], " ", 
   ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.771330756955542*^9, 3.771330759083767*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"017100be-2b23-4e94-9a27-f95c9969b49b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"prob", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"x", "\[Equal]", "0"}], "&&", 
       RowBox[{
        RowBox[{"x", "+", "y"}], "\[Equal]", "1"}], "&&", 
       RowBox[{"y", ">", "5"}]}], "||", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", ">", "0"}], "&&", 
        RowBox[{"y", ">", "0"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"x", "+", "y"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", 
       RowBox[{
        RowBox[{"x", "\[GreaterEqual]", "5"}], "||", 
        RowBox[{"y", ">", "5"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"x", "<", "5"}], "||", 
      RowBox[{"y", ">", "5"}]}]}], "}"}]}], ";"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "x", "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "z", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"VariableDependencies", "[", "prob", "]"}]}], "Input",
 CellChangeTimes->{{3.771330856911059*^9, 3.771330858012227*^9}, 
   3.771330915975724*^9, {3.771330957279179*^9, 3.77133096386961*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"4fc8626a-dca2-443b-935e-87dd44d765ff"],

Cell[BoxData[{
 RowBox[{"prob", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", ">", "6"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", ">", "0"}], "||", 
       RowBox[{"y", ">", "0"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"x", ">", "0"}], "&&", 
        RowBox[{"y", ">", "0"}]}], "||", 
       RowBox[{"x", ">", "1"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"x", ">", "0"}], "||", 
     RowBox[{"y", ">", "0"}], "||", 
     RowBox[{
      RowBox[{"y", ">", "0"}], "&&", 
      RowBox[{"x", "<", "1"}]}]}]}], "}"}]}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "x", "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "y", "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"VariableDependencies", "[", "prob", "]"}], "\n"}], "Input",
 CellChangeTimes->{{3.771330979576202*^9, 3.7713309838287973`*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"5594f69d-185f-4f53-aefb-6812346779c0"],

Cell[BoxData[{
 RowBox[{"prob", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", ">", "6"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", ">", "0"}], "||", 
       RowBox[{"y", ">", "0"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"x", ">", "0"}], "&&", 
        RowBox[{"y", ">", "0"}]}], "||", 
       RowBox[{"x", ">", "1"}]}]}], "}"}], ",", 
    RowBox[{"x", ">", "0"}]}], "}"}]}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "x", "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "y", "}"}]}], "]"}], "\n", 
 RowBox[{"FilterVars", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"VariableDependencies", "[", "prob", "]"}]}], "Input",
 CellChangeTimes->{3.771333601238741*^9},
 CellLabel->"In[44]:=",ExpressionUUID->"cf648683-fddc-426e-9b99-724d563f11ee"]
},
WindowSize->{960, 1148},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
FrontEndVersion->"12.0 for Linux x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 786, 19, 94, "Input",ExpressionUUID->"017100be-2b23-4e94-9a27-f95c9969b49b",
 InitializationCell->True],
Cell[1347, 41, 1436, 41, 124, "Input",ExpressionUUID->"4fc8626a-dca2-443b-935e-87dd44d765ff"],
Cell[2786, 84, 1273, 38, 147, "Input",ExpressionUUID->"5594f69d-185f-4f53-aefb-6812346779c0"],
Cell[4062, 124, 1096, 33, 124, "Input",ExpressionUUID->"cf648683-fddc-426e-9b99-724d563f11ee"]
}
]
*)

